#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_ArmatureCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_ArmatureCFG> Fish_ArmatureCFG::msSingleton(nullptr);

int Fish_ArmatureCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_ArmatureCFGData* Fish_ArmatureCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_ArmatureCFGData>& Fish_ArmatureCFG::GetMapData()
{
	return mMapData;
}

void Fish_ArmatureCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_ArmatureCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_ArmatureCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mResType = element->IntAttribute("ResType");
		data.mResName = element->Attribute("ResName");
		data.mResPath = element->Attribute("ResPath");
		data.mMoveAction = element->Attribute("MoveAction");
		data.mDieAction = element->Attribute("DieAction");
		data.mColor = element->IntAttribute("Color");
		data.mScale = element->FloatAttribute("Scale");
		data.mEnableFlipped = element->BoolAttribute("EnableFlipped");
		{
			const char* Collider = element->Attribute("Collider");
			std::vector<std::string> vecCollider;
			boost::split(vecCollider, Collider, boost::is_any_of(","));
			float temp;
			for (unsigned int i = 0; i < vecCollider.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToFloat(vecCollider[i].c_str(), &temp))
				{
					data.mCollider.push_back(temp);
				}
			}
		}
		{
			const char* AttachArmatures = element->Attribute("AttachArmatures");
			std::vector<std::string> vecAttachArmatures;
			boost::split(vecAttachArmatures, AttachArmatures, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAttachArmatures.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAttachArmatures[i].c_str(), &temp))
				{
					data.mAttachArmatures.push_back(temp);
				}
			}
		}
		data.mFixFlag = element->Attribute("FixFlag");
		{
			const char* Circles = element->Attribute("Circles");
			std::vector<std::string> vecCircles;
			boost::split(vecCircles, Circles, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecCircles.size(); i++)
			{
				data.mCircles.push_back(vecCircles[i]);
			}
		}
		{
			const char* AttachParticles = element->Attribute("AttachParticles");
			std::vector<std::string> vecAttachParticles;
			boost::split(vecAttachParticles, AttachParticles, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecAttachParticles.size(); i++)
			{
				data.mAttachParticles.push_back(vecAttachParticles[i]);
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_ArmatureCFG::Load()
{
	Load("../Config/Fish_ArmatureCFG.xml");
}

Fish_ArmatureCFG* Fish_ArmatureCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_ArmatureCFG());
	}
	return msSingleton.get();
}
